import { FunctionExt, Graph } from '@antv/x6';
import { registry } from './registry';
Graph.Hook.prototype.getAngularContent = function (node) {
    const name = node.getComponentName();
    if (!name) {
        throw new Error(`x6-angular-shape: You have to pass param 'componentName'!`);
    }
    const content = registry.get(name);
    if (content == null) {
        return registry.onNotFound(name);
    }
    if (typeof content === 'function') {
        const contentArgs = FunctionExt.call(content, this.graph, node);
        return contentArgs;
    }
    return content;
};
//# sourceMappingURL=hook.js.map