var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { ApplicationRef, ComponentFactoryResolver, TemplateRef, ViewContainerRef, } from '@angular/core';
import { NodeView, Scheduler } from '@antv/x6';
import { ComponentPortal, DomPortalOutlet, TemplatePortal, } from '@angular/cdk/portal';
export class AngularShapeView extends NodeView {
    init() {
        super.init();
    }
    getContentContainer() {
        return this.selectors.foContent;
    }
    confirmUpdate(flag) {
        const ret = super.confirmUpdate(flag);
        return this.handleAction(ret, AngularShapeView.action, () => {
            Scheduler.scheduleTask(() => this.renderAngularContent());
        });
    }
    renderAngularContent() {
        var _a;
        this.unmountAngularContent();
        const root = this.getContentContainer();
        if (root) {
            const node = this.cell;
            const { injector, content } = this.graph.hook.getAngularContent(node);
            const applicationRef = injector.get(ApplicationRef);
            const viewContainerRef = injector.get(ViewContainerRef);
            const componentFactoryResolver = injector.get(ComponentFactoryResolver);
            const domOutlet = new DomPortalOutlet(root, componentFactoryResolver, applicationRef, injector);
            const ngArguments = ((_a = node.data) === null || _a === void 0 ? void 0 : _a.ngArguments) || {};
            if (content instanceof TemplateRef) {
                const portal = new TemplatePortal(content, viewContainerRef, {
                    ngArguments,
                });
                domOutlet.attachTemplatePortal(portal);
            }
            else {
                const portal = new ComponentPortal(content, viewContainerRef);
                const componentRef = domOutlet.attachComponentPortal(portal);
                Object.keys(ngArguments).forEach((v) => (componentRef.instance[v] = ngArguments[v]));
                componentRef.changeDetectorRef.detectChanges();
            }
        }
    }
    unmountAngularContent() {
        const root = this.getContentContainer();
        root.innerHTML = '';
        return root;
    }
    unmount() {
        this.unmountAngularContent();
        return this;
    }
    dispose() {
        this.unmountAngularContent();
    }
}
__decorate([
    NodeView.dispose()
], AngularShapeView.prototype, "dispose", null);
(function (AngularShapeView) {
    AngularShapeView.action = 'angular';
    AngularShapeView.config({
        bootstrap: [AngularShapeView.action],
        actions: {
            component: AngularShapeView.action,
        },
    });
    NodeView.registry.register('angular-shape-view', AngularShapeView, true);
})(AngularShapeView || (AngularShapeView = {}));
//# sourceMappingURL=view.js.map