"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var x6_1 = require("@antv/x6");
var registry_1 = require("./registry");
x6_1.Graph.Hook.prototype.getAngularContent = function (node) {
    var name = node.getComponentName();
    if (!name) {
        throw new Error("x6-angular-shape: You have to pass param 'componentName'!");
    }
    var content = registry_1.registry.get(name);
    if (content == null) {
        return registry_1.registry.onNotFound(name);
    }
    if (typeof content === 'function') {
        var contentArgs = x6_1.FunctionExt.call(content, this.graph, node);
        return contentArgs;
    }
    return content;
};
//# sourceMappingURL=hook.js.map