"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AngularShapeView = void 0;
var core_1 = require("@angular/core");
var x6_1 = require("@antv/x6");
var portal_1 = require("@angular/cdk/portal");
var AngularShapeView = /** @class */ (function (_super) {
    __extends(AngularShapeView, _super);
    function AngularShapeView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AngularShapeView.prototype.init = function () {
        _super.prototype.init.call(this);
    };
    AngularShapeView.prototype.getContentContainer = function () {
        return this.selectors.foContent;
    };
    AngularShapeView.prototype.confirmUpdate = function (flag) {
        var _this = this;
        var ret = _super.prototype.confirmUpdate.call(this, flag);
        return this.handleAction(ret, AngularShapeView.action, function () {
            x6_1.Scheduler.scheduleTask(function () { return _this.renderAngularContent(); });
        });
    };
    AngularShapeView.prototype.renderAngularContent = function () {
        var _a;
        this.unmountAngularContent();
        var root = this.getContentContainer();
        if (root) {
            var node = this.cell;
            var _b = this.graph.hook.getAngularContent(node), injector = _b.injector, content = _b.content;
            var applicationRef = injector.get(core_1.ApplicationRef);
            var viewContainerRef = injector.get(core_1.ViewContainerRef);
            var componentFactoryResolver = injector.get(core_1.ComponentFactoryResolver);
            var domOutlet = new portal_1.DomPortalOutlet(root, componentFactoryResolver, applicationRef, injector);
            var ngArguments_1 = ((_a = node.data) === null || _a === void 0 ? void 0 : _a.ngArguments) || {};
            if (content instanceof core_1.TemplateRef) {
                var portal = new portal_1.TemplatePortal(content, viewContainerRef, {
                    ngArguments: ngArguments_1,
                });
                domOutlet.attachTemplatePortal(portal);
            }
            else {
                var portal = new portal_1.ComponentPortal(content, viewContainerRef);
                var componentRef_1 = domOutlet.attachComponentPortal(portal);
                Object.keys(ngArguments_1).forEach(function (v) { return (componentRef_1.instance[v] = ngArguments_1[v]); });
                componentRef_1.changeDetectorRef.detectChanges();
            }
        }
    };
    AngularShapeView.prototype.unmountAngularContent = function () {
        var root = this.getContentContainer();
        root.innerHTML = '';
        return root;
    };
    AngularShapeView.prototype.unmount = function () {
        this.unmountAngularContent();
        return this;
    };
    AngularShapeView.prototype.dispose = function () {
        this.unmountAngularContent();
    };
    __decorate([
        x6_1.NodeView.dispose()
    ], AngularShapeView.prototype, "dispose", null);
    return AngularShapeView;
}(x6_1.NodeView));
exports.AngularShapeView = AngularShapeView;
(function (AngularShapeView) {
    AngularShapeView.action = 'angular';
    AngularShapeView.config({
        bootstrap: [AngularShapeView.action],
        actions: {
            component: AngularShapeView.action,
        },
    });
    x6_1.NodeView.registry.register('angular-shape-view', AngularShapeView, true);
})(AngularShapeView = exports.AngularShapeView || (exports.AngularShapeView = {}));
exports.AngularShapeView = AngularShapeView;
//# sourceMappingURL=view.js.map